/* AsyncTask.c generated by valac 0.56.17, the Vala compiler
 * generated from AsyncTask.vala, do not modify */

/*
 * AsyncTask.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gio/gunixoutputstream.h>
#include <gio/gunixinputstream.h>
#include <unistd.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ASYNC_TASK (async_task_get_type ())
#define ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASYNC_TASK, AsyncTask))
#define ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASYNC_TASK, AsyncTaskClass))
#define IS_ASYNC_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASYNC_TASK))
#define IS_ASYNC_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASYNC_TASK))
#define ASYNC_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASYNC_TASK, AsyncTaskClass))

typedef struct _AsyncTask AsyncTask;
typedef struct _AsyncTaskClass AsyncTaskClass;
typedef struct _AsyncTaskPrivate AsyncTaskPrivate;
typedef enum  {
	APP_STATUS_NOT_STARTED,
	APP_STATUS_RUNNING,
	APP_STATUS_PAUSED,
	APP_STATUS_FINISHED,
	APP_STATUS_CANCELLED,
	APP_STATUS_PASSWORD_REQUIRED
} AppStatus;

#define TYPE_APP_STATUS (app_status_get_type ())
enum  {
	ASYNC_TASK_0_PROPERTY,
	ASYNC_TASK_STATUS_LINE_PROPERTY,
	ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY,
	ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY,
	ASYNC_TASK_NUM_PROPERTIES
};
static GParamSpec* async_task_properties[ASYNC_TASK_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	ASYNC_TASK_STDOUT_LINE_READ_SIGNAL,
	ASYNC_TASK_STDERR_LINE_READ_SIGNAL,
	ASYNC_TASK_TASK_COMPLETE_SIGNAL,
	ASYNC_TASK_NUM_SIGNALS
};
static guint async_task_signals[ASYNC_TASK_NUM_SIGNALS] = {0};

struct _AsyncTask {
	GObject parent_instance;
	AsyncTaskPrivate * priv;
	GDataOutputStream* dos_log;
	gboolean is_terminated;
	GPid child_pid;
	gchar* script_file;
	gchar* working_dir;
	gchar* log_file;
	gboolean background_mode;
	AppStatus status;
	GMutex status_line_mutex;
	gint exit_code;
	gchar* error_msg;
	GTimer* timer;
	gdouble progress;
	gdouble percent;
	gint64 prg_count;
	gint64 prg_count_total;
	gint64 prg_bytes;
	gint64 prg_bytes_total;
	gchar* eta;
};

struct _AsyncTaskClass {
	GObjectClass parent_class;
	void (*parse_stdout_line) (AsyncTask* self, const gchar* out_line);
	void (*parse_stderr_line) (AsyncTask* self, const gchar* err_line);
	void (*finish_task) (AsyncTask* self);
};

struct _AsyncTaskPrivate {
	gchar* err_line;
	gchar* out_line;
	GDataOutputStream* dos_in;
	GDataInputStream* dis_out;
	GDataInputStream* dis_err;
	gboolean stdout_is_open;
	gboolean stderr_is_open;
	gint input_fd;
	gint output_fd;
	gint error_fd;
	gboolean finish_called;
	gchar* _status_line;
};

static gint AsyncTask_private_offset;
static gpointer async_task_parent_class = NULL;
VALA_EXTERN gchar* tee_jee_process_helper_TEMP_DIR;

VALA_EXTERN GType async_task_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AsyncTask, g_object_unref)
VALA_EXTERN GType app_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void async_task_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line);
VALA_EXTERN void async_task_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line);
VALA_EXTERN void async_task_finish_task (AsyncTask* self);
static gchar* _async_task_get_status_line (AsyncTask* self);
VALA_EXTERN AsyncTask* async_task_construct (GType object_type);
VALA_EXTERN gchar* tee_jee_misc_timestamp_for_path (void);
VALA_EXTERN gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
VALA_EXTERN gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
VALA_EXTERN gboolean async_task_begin (AsyncTask* self);
VALA_EXTERN void async_task_set_priority (AsyncTask* self);
VALA_EXTERN void tee_jee_logging_log_debug (const gchar* message);
static void ____lambda9_ (AsyncTask* self);
static void async_task_read_stdout (AsyncTask* self);
static gpointer _____lambda9__gthread_func (gpointer self);
VALA_EXTERN void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
static void ____lambda10_ (AsyncTask* self);
static void async_task_read_stderr (AsyncTask* self);
static gpointer _____lambda10__gthread_func (gpointer self);
static void async_task_finish (AsyncTask* self);
VALA_EXTERN void async_task_write_stdin (AsyncTask* self,
                             const gchar* line);
static void async_task_real_parse_stdout_line (AsyncTask* self,
                                        const gchar* out_line);
static void async_task_real_parse_stderr_line (AsyncTask* self,
                                        const gchar* err_line);
VALA_EXTERN gint async_task_read_exit_code (AsyncTask* self);
VALA_EXTERN void async_task_set_status_line (AsyncTask* self,
                                 const gchar* value);
static void async_task_real_finish_task (AsyncTask* self);
VALA_EXTERN gchar* tee_jee_file_system_file_parent (const gchar* file_path);
VALA_EXTERN gboolean tee_jee_file_system_file_exists (const gchar* file_path);
VALA_EXTERN gchar* tee_jee_file_system_file_read (const gchar* file_path);
VALA_EXTERN gboolean async_task_is_running (AsyncTask* self);
VALA_EXTERN void async_task_stop (AsyncTask* self,
                      AppStatus status_to_update);
VALA_EXTERN void tee_jee_process_helper_process_quit (GPid process_pid,
                                          gboolean killChildren);
VALA_EXTERN void async_task_set_priority_value (AsyncTask* self,
                                    gint prio);
VALA_EXTERN void tee_jee_process_helper_process_set_priority (GPid procID,
                                                  gint prio);
VALA_EXTERN gint* tee_jee_process_helper_get_process_children (GPid parent_pid,
                                                   gint* result_length1);
VALA_EXTERN void async_task_print_app_status (AsyncTask* self);
VALA_EXTERN gchar* async_task_get_status_line (AsyncTask* self);
VALA_EXTERN gchar* async_task_get_stat_time_elapsed (AsyncTask* self);
VALA_EXTERN gulong tee_jee_system_timer_elapsed (GTimer* timer,
                                     gboolean stop);
VALA_EXTERN gchar* tee_jee_misc_format_duration (glong millis);
VALA_EXTERN gchar* async_task_get_stat_time_remaining (AsyncTask* self);
static void async_task_finalize (GObject * obj);
static GType async_task_get_type_once (void);
static void _vala_async_task_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_async_task_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

static inline gpointer
async_task_get_instance_private (AsyncTask* self)
{
	return G_STRUCT_MEMBER_P (self, AsyncTask_private_offset);
}

static gchar*
_async_task_get_status_line (AsyncTask* self)
{
	gchar* ret = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 94 "../src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../src/Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 95 "../src/Utility/AsyncTask.vala"
	ret = _tmp0_;
#line 97 "../src/Utility/AsyncTask.vala"
	if (g_mutex_trylock (&self->status_line_mutex)) {
#line 249 "AsyncTask.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 98 "../src/Utility/AsyncTask.vala"
		_tmp1_ = self->priv->_status_line;
#line 98 "../src/Utility/AsyncTask.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 98 "../src/Utility/AsyncTask.vala"
		_g_free0 (ret);
#line 98 "../src/Utility/AsyncTask.vala"
		ret = _tmp2_;
#line 99 "../src/Utility/AsyncTask.vala"
		g_mutex_unlock (&self->status_line_mutex);
#line 262 "AsyncTask.c"
	}
#line 102 "../src/Utility/AsyncTask.vala"
	result = ret;
#line 102 "../src/Utility/AsyncTask.vala"
	return result;
#line 268 "AsyncTask.c"
}

AsyncTask*
async_task_construct (GType object_type)
{
	AsyncTask * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
#line 105 "../src/Utility/AsyncTask.vala"
	self = (AsyncTask*) g_object_new (object_type, NULL);
#line 107 "../src/Utility/AsyncTask.vala"
	_tmp0_ = tee_jee_process_helper_TEMP_DIR;
#line 107 "../src/Utility/AsyncTask.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 107 "../src/Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 107 "../src/Utility/AsyncTask.vala"
	_tmp3_ = tee_jee_misc_timestamp_for_path ();
#line 107 "../src/Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 107 "../src/Utility/AsyncTask.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 107 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->working_dir);
#line 107 "../src/Utility/AsyncTask.vala"
	self->working_dir = _tmp5_;
#line 107 "../src/Utility/AsyncTask.vala"
	_g_free0 (_tmp4_);
#line 107 "../src/Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 108 "../src/Utility/AsyncTask.vala"
	_tmp6_ = self->working_dir;
#line 108 "../src/Utility/AsyncTask.vala"
	_tmp7_ = tee_jee_file_system_path_combine (_tmp6_, "script.sh");
#line 108 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->script_file);
#line 108 "../src/Utility/AsyncTask.vala"
	self->script_file = _tmp7_;
#line 109 "../src/Utility/AsyncTask.vala"
	_tmp8_ = self->working_dir;
#line 109 "../src/Utility/AsyncTask.vala"
	_tmp9_ = tee_jee_file_system_path_combine (_tmp8_, "task.log");
#line 109 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->log_file);
#line 109 "../src/Utility/AsyncTask.vala"
	self->log_file = _tmp9_;
#line 112 "../src/Utility/AsyncTask.vala"
	_vala_clear_GMutex (&self->status_line_mutex);
#line 112 "../src/Utility/AsyncTask.vala"
	g_mutex_init (&self->status_line_mutex);
#line 114 "../src/Utility/AsyncTask.vala"
	_tmp10_ = self->working_dir;
#line 114 "../src/Utility/AsyncTask.vala"
	tee_jee_file_system_dir_create (_tmp10_, FALSE);
#line 105 "../src/Utility/AsyncTask.vala"
	return self;
#line 334 "AsyncTask.c"
}

static void
____lambda9_ (AsyncTask* self)
{
#line 177 "../src/Utility/AsyncTask.vala"
	async_task_read_stdout (self);
#line 342 "AsyncTask.c"
}

static gpointer
_____lambda9__gthread_func (gpointer self)
{
	gpointer result;
#line 177 "../src/Utility/AsyncTask.vala"
	____lambda9_ ((AsyncTask*) self);
#line 351 "AsyncTask.c"
	result = NULL;
#line 177 "../src/Utility/AsyncTask.vala"
	g_object_unref (self);
#line 177 "../src/Utility/AsyncTask.vala"
	return result;
#line 357 "AsyncTask.c"
}

static void
____lambda10_ (AsyncTask* self)
{
#line 185 "../src/Utility/AsyncTask.vala"
	async_task_read_stderr (self);
#line 365 "AsyncTask.c"
}

static gpointer
_____lambda10__gthread_func (gpointer self)
{
	gpointer result;
#line 185 "../src/Utility/AsyncTask.vala"
	____lambda10_ ((AsyncTask*) self);
#line 374 "AsyncTask.c"
	result = NULL;
#line 185 "../src/Utility/AsyncTask.vala"
	g_object_unref (self);
#line 185 "../src/Utility/AsyncTask.vala"
	return result;
#line 380 "AsyncTask.c"
}

gboolean
async_task_begin (AsyncTask* self)
{
	gboolean has_started = FALSE;
	gchar* _tmp0_;
	gchar** spawn_args = NULL;
	gchar** _tmp1_;
	gint spawn_args_length1;
	gint _spawn_args_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar** spawn_env = NULL;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint spawn_env_length1;
	gint _spawn_env_size_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 117 "../src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 119 "../src/Utility/AsyncTask.vala"
	self->status = APP_STATUS_RUNNING;
#line 121 "../src/Utility/AsyncTask.vala"
	has_started = TRUE;
#line 122 "../src/Utility/AsyncTask.vala"
	self->is_terminated = FALSE;
#line 123 "../src/Utility/AsyncTask.vala"
	self->priv->finish_called = FALSE;
#line 125 "../src/Utility/AsyncTask.vala"
	self->prg_count = (gint64) 0;
#line 126 "../src/Utility/AsyncTask.vala"
	self->prg_bytes = (gint64) 0;
#line 127 "../src/Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 127 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->error_msg);
#line 127 "../src/Utility/AsyncTask.vala"
	self->error_msg = _tmp0_;
#line 129 "../src/Utility/AsyncTask.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 129 "../src/Utility/AsyncTask.vala"
	spawn_args = _tmp1_;
#line 129 "../src/Utility/AsyncTask.vala"
	spawn_args_length1 = 1;
#line 129 "../src/Utility/AsyncTask.vala"
	_spawn_args_size_ = spawn_args_length1;
#line 130 "../src/Utility/AsyncTask.vala"
	_tmp2_ = spawn_args;
#line 130 "../src/Utility/AsyncTask.vala"
	_tmp2__length1 = spawn_args_length1;
#line 130 "../src/Utility/AsyncTask.vala"
	_tmp3_ = self->script_file;
#line 130 "../src/Utility/AsyncTask.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 130 "../src/Utility/AsyncTask.vala"
	_g_free0 (_tmp2_[0]);
#line 130 "../src/Utility/AsyncTask.vala"
	_tmp2_[0] = _tmp4_;
#line 132 "../src/Utility/AsyncTask.vala"
	_tmp6_ = _tmp5_ = g_get_environ ();
#line 132 "../src/Utility/AsyncTask.vala"
	spawn_env = _tmp6_;
#line 132 "../src/Utility/AsyncTask.vala"
	spawn_env_length1 = _vala_array_length (_tmp5_);
#line 132 "../src/Utility/AsyncTask.vala"
	_spawn_env_size_ = spawn_env_length1;
#line 451 "AsyncTask.c"
	{
		GTimer* _tmp7_;
		GTimer* _tmp8_;
		const gchar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		gchar** _tmp11_;
		gint _tmp11__length1;
		GPid _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GUnixOutputStream* uos_in = NULL;
		GUnixOutputStream* _tmp18_;
		GUnixInputStream* uis_out = NULL;
		GUnixInputStream* _tmp19_;
		GUnixInputStream* uis_err = NULL;
		GUnixInputStream* _tmp20_;
		GUnixOutputStream* _tmp21_;
		GDataOutputStream* _tmp22_;
		GUnixInputStream* _tmp23_;
		GDataInputStream* _tmp24_;
		GUnixInputStream* _tmp25_;
		GDataInputStream* _tmp26_;
		GDataInputStream* _tmp27_;
		GDataInputStream* _tmp28_;
		const gchar* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
#line 136 "../src/Utility/AsyncTask.vala"
		_tmp7_ = g_timer_new ();
#line 136 "../src/Utility/AsyncTask.vala"
		_g_timer_destroy0 (self->timer);
#line 136 "../src/Utility/AsyncTask.vala"
		self->timer = _tmp7_;
#line 137 "../src/Utility/AsyncTask.vala"
		_tmp8_ = self->timer;
#line 137 "../src/Utility/AsyncTask.vala"
		g_timer_start (_tmp8_);
#line 140 "../src/Utility/AsyncTask.vala"
		_tmp9_ = self->working_dir;
#line 140 "../src/Utility/AsyncTask.vala"
		_tmp10_ = spawn_args;
#line 140 "../src/Utility/AsyncTask.vala"
		_tmp10__length1 = spawn_args_length1;
#line 140 "../src/Utility/AsyncTask.vala"
		_tmp11_ = spawn_env;
#line 140 "../src/Utility/AsyncTask.vala"
		_tmp11__length1 = spawn_env_length1;
#line 140 "../src/Utility/AsyncTask.vala"
		g_spawn_async_with_pipes (_tmp9_, _tmp10_, _tmp11_, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_, &_inner_error0_);
#line 140 "../src/Utility/AsyncTask.vala"
		self->child_pid = _tmp12_;
#line 140 "../src/Utility/AsyncTask.vala"
		self->priv->input_fd = _tmp13_;
#line 140 "../src/Utility/AsyncTask.vala"
		self->priv->output_fd = _tmp14_;
#line 140 "../src/Utility/AsyncTask.vala"
		self->priv->error_fd = _tmp15_;
#line 140 "../src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 515 "AsyncTask.c"
			goto __catch0_g_error;
		}
#line 151 "../src/Utility/AsyncTask.vala"
		async_task_set_priority (self);
#line 153 "../src/Utility/AsyncTask.vala"
		_tmp16_ = g_strdup_printf ("AsyncTask: child_pid: %d", (gint) self->child_pid);
#line 153 "../src/Utility/AsyncTask.vala"
		_tmp17_ = _tmp16_;
#line 153 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_debug (_tmp17_);
#line 153 "../src/Utility/AsyncTask.vala"
		_g_free0 (_tmp17_);
#line 156 "../src/Utility/AsyncTask.vala"
		_tmp18_ = (GUnixOutputStream*) g_unix_output_stream_new (self->priv->input_fd, FALSE);
#line 156 "../src/Utility/AsyncTask.vala"
		uos_in = _tmp18_;
#line 157 "../src/Utility/AsyncTask.vala"
		_tmp19_ = (GUnixInputStream*) g_unix_input_stream_new (self->priv->output_fd, FALSE);
#line 157 "../src/Utility/AsyncTask.vala"
		uis_out = _tmp19_;
#line 158 "../src/Utility/AsyncTask.vala"
		_tmp20_ = (GUnixInputStream*) g_unix_input_stream_new (self->priv->error_fd, FALSE);
#line 158 "../src/Utility/AsyncTask.vala"
		uis_err = _tmp20_;
#line 159 "../src/Utility/AsyncTask.vala"
		_tmp21_ = uos_in;
#line 159 "../src/Utility/AsyncTask.vala"
		_tmp22_ = g_data_output_stream_new ((GOutputStream*) _tmp21_);
#line 159 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dos_in);
#line 159 "../src/Utility/AsyncTask.vala"
		self->priv->dos_in = _tmp22_;
#line 160 "../src/Utility/AsyncTask.vala"
		_tmp23_ = uis_out;
#line 160 "../src/Utility/AsyncTask.vala"
		_tmp24_ = g_data_input_stream_new ((GInputStream*) _tmp23_);
#line 160 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_out);
#line 160 "../src/Utility/AsyncTask.vala"
		self->priv->dis_out = _tmp24_;
#line 161 "../src/Utility/AsyncTask.vala"
		_tmp25_ = uis_err;
#line 161 "../src/Utility/AsyncTask.vala"
		_tmp26_ = g_data_input_stream_new ((GInputStream*) _tmp25_);
#line 161 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_err);
#line 161 "../src/Utility/AsyncTask.vala"
		self->priv->dis_err = _tmp26_;
#line 162 "../src/Utility/AsyncTask.vala"
		_tmp27_ = self->priv->dis_out;
#line 162 "../src/Utility/AsyncTask.vala"
		g_data_input_stream_set_newline_type (_tmp27_, G_DATA_STREAM_NEWLINE_TYPE_ANY);
#line 163 "../src/Utility/AsyncTask.vala"
		_tmp28_ = self->priv->dis_err;
#line 163 "../src/Utility/AsyncTask.vala"
		g_data_input_stream_set_newline_type (_tmp28_, G_DATA_STREAM_NEWLINE_TYPE_ANY);
#line 166 "../src/Utility/AsyncTask.vala"
		_tmp29_ = self->log_file;
#line 166 "../src/Utility/AsyncTask.vala"
		_tmp30_ = strlen (_tmp29_);
#line 166 "../src/Utility/AsyncTask.vala"
		_tmp31_ = _tmp30_;
#line 166 "../src/Utility/AsyncTask.vala"
		if (_tmp31_ > 0) {
#line 580 "AsyncTask.c"
			GFile* file = NULL;
			const gchar* _tmp32_;
			GFile* _tmp33_;
			GFile* _tmp34_;
			GFileOutputStream* file_stream = NULL;
			GFile* _tmp36_;
			GFileOutputStream* _tmp37_;
			GFileOutputStream* _tmp38_;
			GDataOutputStream* _tmp39_;
#line 167 "../src/Utility/AsyncTask.vala"
			_tmp32_ = self->log_file;
#line 167 "../src/Utility/AsyncTask.vala"
			_tmp33_ = g_file_new_for_path (_tmp32_);
#line 167 "../src/Utility/AsyncTask.vala"
			file = _tmp33_;
#line 168 "../src/Utility/AsyncTask.vala"
			_tmp34_ = file;
#line 168 "../src/Utility/AsyncTask.vala"
			if (g_file_query_exists (_tmp34_, NULL)) {
#line 600 "AsyncTask.c"
				GFile* _tmp35_;
#line 169 "../src/Utility/AsyncTask.vala"
				_tmp35_ = file;
#line 169 "../src/Utility/AsyncTask.vala"
				g_file_delete (_tmp35_, NULL, &_inner_error0_);
#line 169 "../src/Utility/AsyncTask.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../src/Utility/AsyncTask.vala"
					_g_object_unref0 (file);
#line 169 "../src/Utility/AsyncTask.vala"
					_g_object_unref0 (uis_err);
#line 169 "../src/Utility/AsyncTask.vala"
					_g_object_unref0 (uis_out);
#line 169 "../src/Utility/AsyncTask.vala"
					_g_object_unref0 (uos_in);
#line 616 "AsyncTask.c"
					goto __catch0_g_error;
				}
			}
#line 171 "../src/Utility/AsyncTask.vala"
			_tmp36_ = file;
#line 171 "../src/Utility/AsyncTask.vala"
			_tmp37_ = g_file_create (_tmp36_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 171 "../src/Utility/AsyncTask.vala"
			file_stream = _tmp37_;
#line 171 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/Utility/AsyncTask.vala"
				_g_object_unref0 (file);
#line 171 "../src/Utility/AsyncTask.vala"
				_g_object_unref0 (uis_err);
#line 171 "../src/Utility/AsyncTask.vala"
				_g_object_unref0 (uis_out);
#line 171 "../src/Utility/AsyncTask.vala"
				_g_object_unref0 (uos_in);
#line 636 "AsyncTask.c"
				goto __catch0_g_error;
			}
#line 172 "../src/Utility/AsyncTask.vala"
			_tmp38_ = file_stream;
#line 172 "../src/Utility/AsyncTask.vala"
			_tmp39_ = g_data_output_stream_new ((GOutputStream*) _tmp38_);
#line 172 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (self->dos_log);
#line 172 "../src/Utility/AsyncTask.vala"
			self->dos_log = _tmp39_;
#line 166 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (file_stream);
#line 166 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (file);
#line 651 "AsyncTask.c"
		}
		{
			GThread* _tmp40_;
			GThread* _tmp41_;
#line 177 "../src/Utility/AsyncTask.vala"
			_tmp40_ = g_thread_try_new ("async-task-stdout-reader", _____lambda9__gthread_func, g_object_ref (self), &_inner_error0_);
#line 177 "../src/Utility/AsyncTask.vala"
			_tmp41_ = _tmp40_;
#line 177 "../src/Utility/AsyncTask.vala"
			_g_thread_unref0 (_tmp41_);
#line 177 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 664 "AsyncTask.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp42_;
			const gchar* _tmp43_;
#line 175 "../src/Utility/AsyncTask.vala"
			e = _inner_error0_;
#line 175 "../src/Utility/AsyncTask.vala"
			_inner_error0_ = NULL;
#line 179 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.begin():create_thread:read_stdout()", FALSE, FALSE);
#line 180 "../src/Utility/AsyncTask.vala"
			_tmp42_ = e;
#line 180 "../src/Utility/AsyncTask.vala"
			_tmp43_ = _tmp42_->message;
#line 180 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error (_tmp43_, FALSE, FALSE);
#line 175 "../src/Utility/AsyncTask.vala"
			_g_error_free0 (e);
#line 688 "AsyncTask.c"
		}
		__finally1:
#line 175 "../src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 175 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (uis_err);
#line 175 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (uis_out);
#line 175 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (uos_in);
#line 699 "AsyncTask.c"
			goto __catch0_g_error;
		}
		{
			GThread* _tmp44_;
			GThread* _tmp45_;
#line 185 "../src/Utility/AsyncTask.vala"
			_tmp44_ = g_thread_try_new ("async-task-stderr-reader", _____lambda10__gthread_func, g_object_ref (self), &_inner_error0_);
#line 185 "../src/Utility/AsyncTask.vala"
			_tmp45_ = _tmp44_;
#line 185 "../src/Utility/AsyncTask.vala"
			_g_thread_unref0 (_tmp45_);
#line 185 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 713 "AsyncTask.c"
				goto __catch2_g_error;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp46_;
			const gchar* _tmp47_;
#line 183 "../src/Utility/AsyncTask.vala"
			e = _inner_error0_;
#line 183 "../src/Utility/AsyncTask.vala"
			_inner_error0_ = NULL;
#line 187 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.begin():create_thread:read_stderr()", FALSE, FALSE);
#line 188 "../src/Utility/AsyncTask.vala"
			_tmp46_ = e;
#line 188 "../src/Utility/AsyncTask.vala"
			_tmp47_ = _tmp46_->message;
#line 188 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error (_tmp47_, FALSE, FALSE);
#line 183 "../src/Utility/AsyncTask.vala"
			_g_error_free0 (e);
#line 737 "AsyncTask.c"
		}
		__finally2:
#line 183 "../src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (uis_err);
#line 183 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (uis_out);
#line 183 "../src/Utility/AsyncTask.vala"
			_g_object_unref0 (uos_in);
#line 748 "AsyncTask.c"
			goto __catch0_g_error;
		}
#line 134 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (uis_err);
#line 134 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (uis_out);
#line 134 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (uos_in);
#line 757 "AsyncTask.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp48_;
		const gchar* _tmp49_;
#line 134 "../src/Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 134 "../src/Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 192 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.begin()", FALSE, FALSE);
#line 193 "../src/Utility/AsyncTask.vala"
		_tmp48_ = e;
#line 193 "../src/Utility/AsyncTask.vala"
		_tmp49_ = _tmp48_->message;
#line 193 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp49_, FALSE, FALSE);
#line 194 "../src/Utility/AsyncTask.vala"
		has_started = FALSE;
#line 134 "../src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 781 "AsyncTask.c"
	}
	__finally0:
#line 134 "../src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 786 "AsyncTask.c"
		gboolean _tmp50_ = FALSE;
#line 134 "../src/Utility/AsyncTask.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 134 "../src/Utility/AsyncTask.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 134 "../src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "../src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 134 "../src/Utility/AsyncTask.vala"
		return _tmp50_;
#line 798 "AsyncTask.c"
	}
#line 198 "../src/Utility/AsyncTask.vala"
	result = has_started;
#line 198 "../src/Utility/AsyncTask.vala"
	spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 198 "../src/Utility/AsyncTask.vala"
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 198 "../src/Utility/AsyncTask.vala"
	return result;
#line 808 "AsyncTask.c"
}

static void
async_task_read_stdout (AsyncTask* self)
{
	GError* _inner_error0_ = NULL;
#line 201 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 817 "AsyncTask.c"
	{
		gchar* _tmp0_ = NULL;
		GDataInputStream* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp15_ = FALSE;
		GDataInputStream* _tmp16_;
		gboolean _tmp19_ = FALSE;
#line 203 "../src/Utility/AsyncTask.vala"
		self->priv->stdout_is_open = TRUE;
#line 205 "../src/Utility/AsyncTask.vala"
		_tmp1_ = self->priv->dis_out;
#line 205 "../src/Utility/AsyncTask.vala"
		_tmp2_ = g_data_input_stream_read_line (_tmp1_, NULL, NULL, &_inner_error0_);
#line 205 "../src/Utility/AsyncTask.vala"
		_tmp0_ = _tmp2_;
#line 205 "../src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 836 "AsyncTask.c"
			goto __catch0_g_error;
		}
#line 205 "../src/Utility/AsyncTask.vala"
		_tmp3_ = _tmp0_;
#line 205 "../src/Utility/AsyncTask.vala"
		_tmp0_ = NULL;
#line 205 "../src/Utility/AsyncTask.vala"
		_g_free0 (self->priv->out_line);
#line 205 "../src/Utility/AsyncTask.vala"
		self->priv->out_line = _tmp3_;
#line 206 "../src/Utility/AsyncTask.vala"
		while (TRUE) {
#line 849 "AsyncTask.c"
			const gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gchar* _tmp11_ = NULL;
			GDataInputStream* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 206 "../src/Utility/AsyncTask.vala"
			_tmp4_ = self->priv->out_line;
#line 206 "../src/Utility/AsyncTask.vala"
			if (!(_tmp4_ != NULL)) {
#line 206 "../src/Utility/AsyncTask.vala"
				break;
#line 862 "AsyncTask.c"
			}
#line 208 "../src/Utility/AsyncTask.vala"
			if (!self->is_terminated) {
#line 866 "AsyncTask.c"
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 208 "../src/Utility/AsyncTask.vala"
				_tmp6_ = self->priv->out_line;
#line 208 "../src/Utility/AsyncTask.vala"
				_tmp7_ = strlen (_tmp6_);
#line 208 "../src/Utility/AsyncTask.vala"
				_tmp8_ = _tmp7_;
#line 208 "../src/Utility/AsyncTask.vala"
				_tmp5_ = _tmp8_ > 0;
#line 878 "AsyncTask.c"
			} else {
#line 208 "../src/Utility/AsyncTask.vala"
				_tmp5_ = FALSE;
#line 882 "AsyncTask.c"
			}
#line 208 "../src/Utility/AsyncTask.vala"
			if (_tmp5_) {
#line 886 "AsyncTask.c"
				const gchar* _tmp9_;
				const gchar* _tmp10_;
#line 209 "../src/Utility/AsyncTask.vala"
				_tmp9_ = self->priv->out_line;
#line 209 "../src/Utility/AsyncTask.vala"
				async_task_parse_stdout_line (self, _tmp9_);
#line 210 "../src/Utility/AsyncTask.vala"
				_tmp10_ = self->priv->out_line;
#line 210 "../src/Utility/AsyncTask.vala"
				g_signal_emit (self, async_task_signals[ASYNC_TASK_STDOUT_LINE_READ_SIGNAL], 0, _tmp10_);
#line 897 "AsyncTask.c"
			}
#line 212 "../src/Utility/AsyncTask.vala"
			_tmp12_ = self->priv->dis_out;
#line 212 "../src/Utility/AsyncTask.vala"
			_tmp13_ = g_data_input_stream_read_line (_tmp12_, NULL, NULL, &_inner_error0_);
#line 212 "../src/Utility/AsyncTask.vala"
			_tmp11_ = _tmp13_;
#line 212 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../src/Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 909 "AsyncTask.c"
				goto __catch0_g_error;
			}
#line 212 "../src/Utility/AsyncTask.vala"
			_tmp14_ = _tmp11_;
#line 212 "../src/Utility/AsyncTask.vala"
			_tmp11_ = NULL;
#line 212 "../src/Utility/AsyncTask.vala"
			_g_free0 (self->priv->out_line);
#line 212 "../src/Utility/AsyncTask.vala"
			self->priv->out_line = _tmp14_;
#line 206 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp11_);
#line 922 "AsyncTask.c"
		}
#line 215 "../src/Utility/AsyncTask.vala"
		self->priv->stdout_is_open = FALSE;
#line 218 "../src/Utility/AsyncTask.vala"
		_tmp16_ = self->priv->dis_out;
#line 218 "../src/Utility/AsyncTask.vala"
		if (_tmp16_ != NULL) {
#line 930 "AsyncTask.c"
			GDataInputStream* _tmp17_;
#line 218 "../src/Utility/AsyncTask.vala"
			_tmp17_ = self->priv->dis_out;
#line 218 "../src/Utility/AsyncTask.vala"
			_tmp15_ = !g_input_stream_is_closed ((GInputStream*) _tmp17_);
#line 936 "AsyncTask.c"
		} else {
#line 218 "../src/Utility/AsyncTask.vala"
			_tmp15_ = FALSE;
#line 940 "AsyncTask.c"
		}
#line 218 "../src/Utility/AsyncTask.vala"
		if (_tmp15_) {
#line 944 "AsyncTask.c"
			GDataInputStream* _tmp18_;
#line 219 "../src/Utility/AsyncTask.vala"
			_tmp18_ = self->priv->dis_out;
#line 219 "../src/Utility/AsyncTask.vala"
			g_input_stream_close ((GInputStream*) _tmp18_, NULL, &_inner_error0_);
#line 219 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 954 "AsyncTask.c"
				goto __catch0_g_error;
			}
		}
#line 222 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_out);
#line 222 "../src/Utility/AsyncTask.vala"
		self->priv->dis_out = NULL;
#line 223 "../src/Utility/AsyncTask.vala"
		close (self->priv->output_fd);
#line 226 "../src/Utility/AsyncTask.vala"
		if (!self->priv->stdout_is_open) {
#line 226 "../src/Utility/AsyncTask.vala"
			_tmp19_ = !self->priv->stderr_is_open;
#line 968 "AsyncTask.c"
		} else {
#line 226 "../src/Utility/AsyncTask.vala"
			_tmp19_ = FALSE;
#line 972 "AsyncTask.c"
		}
#line 226 "../src/Utility/AsyncTask.vala"
		if (_tmp19_) {
#line 227 "../src/Utility/AsyncTask.vala"
			async_task_finish (self);
#line 978 "AsyncTask.c"
		}
#line 202 "../src/Utility/AsyncTask.vala"
		_g_free0 (_tmp0_);
#line 982 "AsyncTask.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 202 "../src/Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 202 "../src/Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 231 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.read_stdout()", FALSE, FALSE);
#line 232 "../src/Utility/AsyncTask.vala"
		_tmp20_ = e;
#line 232 "../src/Utility/AsyncTask.vala"
		_tmp21_ = _tmp20_->message;
#line 232 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp21_, FALSE, FALSE);
#line 202 "../src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1004 "AsyncTask.c"
	}
	__finally0:
#line 202 "../src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 202 "../src/Utility/AsyncTask.vala"
		return;
#line 1015 "AsyncTask.c"
	}
}

static void
async_task_read_stderr (AsyncTask* self)
{
	GError* _inner_error0_ = NULL;
#line 236 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 1025 "AsyncTask.c"
	{
		gchar* _tmp0_ = NULL;
		GDataInputStream* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp20_ = FALSE;
		GDataInputStream* _tmp21_;
		gboolean _tmp24_ = FALSE;
#line 238 "../src/Utility/AsyncTask.vala"
		self->priv->stderr_is_open = TRUE;
#line 240 "../src/Utility/AsyncTask.vala"
		_tmp1_ = self->priv->dis_err;
#line 240 "../src/Utility/AsyncTask.vala"
		_tmp2_ = g_data_input_stream_read_line (_tmp1_, NULL, NULL, &_inner_error0_);
#line 240 "../src/Utility/AsyncTask.vala"
		_tmp0_ = _tmp2_;
#line 240 "../src/Utility/AsyncTask.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1044 "AsyncTask.c"
			goto __catch0_g_error;
		}
#line 240 "../src/Utility/AsyncTask.vala"
		_tmp3_ = _tmp0_;
#line 240 "../src/Utility/AsyncTask.vala"
		_tmp0_ = NULL;
#line 240 "../src/Utility/AsyncTask.vala"
		_g_free0 (self->priv->err_line);
#line 240 "../src/Utility/AsyncTask.vala"
		self->priv->err_line = _tmp3_;
#line 241 "../src/Utility/AsyncTask.vala"
		while (TRUE) {
#line 1057 "AsyncTask.c"
			const gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gchar* _tmp16_ = NULL;
			GDataInputStream* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 241 "../src/Utility/AsyncTask.vala"
			_tmp4_ = self->priv->err_line;
#line 241 "../src/Utility/AsyncTask.vala"
			if (!(_tmp4_ != NULL)) {
#line 241 "../src/Utility/AsyncTask.vala"
				break;
#line 1070 "AsyncTask.c"
			}
#line 242 "../src/Utility/AsyncTask.vala"
			if (!self->is_terminated) {
#line 1074 "AsyncTask.c"
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 242 "../src/Utility/AsyncTask.vala"
				_tmp6_ = self->priv->err_line;
#line 242 "../src/Utility/AsyncTask.vala"
				_tmp7_ = strlen (_tmp6_);
#line 242 "../src/Utility/AsyncTask.vala"
				_tmp8_ = _tmp7_;
#line 242 "../src/Utility/AsyncTask.vala"
				_tmp5_ = _tmp8_ > 0;
#line 1086 "AsyncTask.c"
			} else {
#line 242 "../src/Utility/AsyncTask.vala"
				_tmp5_ = FALSE;
#line 1090 "AsyncTask.c"
			}
#line 242 "../src/Utility/AsyncTask.vala"
			if (_tmp5_) {
#line 1094 "AsyncTask.c"
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
#line 243 "../src/Utility/AsyncTask.vala"
				_tmp9_ = self->error_msg;
#line 243 "../src/Utility/AsyncTask.vala"
				_tmp10_ = self->priv->err_line;
#line 243 "../src/Utility/AsyncTask.vala"
				_tmp11_ = g_strdup_printf ("%s\n", _tmp10_);
#line 243 "../src/Utility/AsyncTask.vala"
				_tmp12_ = _tmp11_;
#line 243 "../src/Utility/AsyncTask.vala"
				_tmp13_ = g_strconcat (_tmp9_, _tmp12_, NULL);
#line 243 "../src/Utility/AsyncTask.vala"
				_g_free0 (self->error_msg);
#line 243 "../src/Utility/AsyncTask.vala"
				self->error_msg = _tmp13_;
#line 243 "../src/Utility/AsyncTask.vala"
				_g_free0 (_tmp12_);
#line 245 "../src/Utility/AsyncTask.vala"
				_tmp14_ = self->priv->err_line;
#line 245 "../src/Utility/AsyncTask.vala"
				async_task_parse_stderr_line (self, _tmp14_);
#line 246 "../src/Utility/AsyncTask.vala"
				_tmp15_ = self->priv->err_line;
#line 246 "../src/Utility/AsyncTask.vala"
				g_signal_emit (self, async_task_signals[ASYNC_TASK_STDERR_LINE_READ_SIGNAL], 0, _tmp15_);
#line 1126 "AsyncTask.c"
			}
#line 248 "../src/Utility/AsyncTask.vala"
			_tmp17_ = self->priv->dis_err;
#line 248 "../src/Utility/AsyncTask.vala"
			_tmp18_ = g_data_input_stream_read_line (_tmp17_, NULL, NULL, &_inner_error0_);
#line 248 "../src/Utility/AsyncTask.vala"
			_tmp16_ = _tmp18_;
#line 248 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 1138 "AsyncTask.c"
				goto __catch0_g_error;
			}
#line 248 "../src/Utility/AsyncTask.vala"
			_tmp19_ = _tmp16_;
#line 248 "../src/Utility/AsyncTask.vala"
			_tmp16_ = NULL;
#line 248 "../src/Utility/AsyncTask.vala"
			_g_free0 (self->priv->err_line);
#line 248 "../src/Utility/AsyncTask.vala"
			self->priv->err_line = _tmp19_;
#line 241 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp16_);
#line 1151 "AsyncTask.c"
		}
#line 251 "../src/Utility/AsyncTask.vala"
		self->priv->stderr_is_open = FALSE;
#line 254 "../src/Utility/AsyncTask.vala"
		_tmp21_ = self->priv->dis_err;
#line 254 "../src/Utility/AsyncTask.vala"
		if (_tmp21_ != NULL) {
#line 1159 "AsyncTask.c"
			GDataInputStream* _tmp22_;
#line 254 "../src/Utility/AsyncTask.vala"
			_tmp22_ = self->priv->dis_err;
#line 254 "../src/Utility/AsyncTask.vala"
			_tmp20_ = !g_input_stream_is_closed ((GInputStream*) _tmp22_);
#line 1165 "AsyncTask.c"
		} else {
#line 254 "../src/Utility/AsyncTask.vala"
			_tmp20_ = FALSE;
#line 1169 "AsyncTask.c"
		}
#line 254 "../src/Utility/AsyncTask.vala"
		if (_tmp20_) {
#line 1173 "AsyncTask.c"
			GDataInputStream* _tmp23_;
#line 255 "../src/Utility/AsyncTask.vala"
			_tmp23_ = self->priv->dis_err;
#line 255 "../src/Utility/AsyncTask.vala"
			g_input_stream_close ((GInputStream*) _tmp23_, NULL, &_inner_error0_);
#line 255 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 255 "../src/Utility/AsyncTask.vala"
				_g_free0 (_tmp0_);
#line 1183 "AsyncTask.c"
				goto __catch0_g_error;
			}
		}
#line 258 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->priv->dis_err);
#line 258 "../src/Utility/AsyncTask.vala"
		self->priv->dis_err = NULL;
#line 259 "../src/Utility/AsyncTask.vala"
		close (self->priv->error_fd);
#line 262 "../src/Utility/AsyncTask.vala"
		if (!self->priv->stdout_is_open) {
#line 262 "../src/Utility/AsyncTask.vala"
			_tmp24_ = !self->priv->stderr_is_open;
#line 1197 "AsyncTask.c"
		} else {
#line 262 "../src/Utility/AsyncTask.vala"
			_tmp24_ = FALSE;
#line 1201 "AsyncTask.c"
		}
#line 262 "../src/Utility/AsyncTask.vala"
		if (_tmp24_) {
#line 263 "../src/Utility/AsyncTask.vala"
			async_task_finish (self);
#line 1207 "AsyncTask.c"
		}
#line 237 "../src/Utility/AsyncTask.vala"
		_g_free0 (_tmp0_);
#line 1211 "AsyncTask.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 237 "../src/Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 237 "../src/Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 267 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error ("AsyncTask.read_stderr()", FALSE, FALSE);
#line 268 "../src/Utility/AsyncTask.vala"
		_tmp25_ = e;
#line 268 "../src/Utility/AsyncTask.vala"
		_tmp26_ = _tmp25_->message;
#line 268 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp26_, FALSE, FALSE);
#line 237 "../src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1233 "AsyncTask.c"
	}
	__finally0:
#line 237 "../src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 237 "../src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 237 "../src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 237 "../src/Utility/AsyncTask.vala"
		return;
#line 1244 "AsyncTask.c"
	}
}

void
async_task_write_stdin (AsyncTask* self,
                        const gchar* line)
{
	GError* _inner_error0_ = NULL;
#line 272 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (line != NULL);
#line 1257 "AsyncTask.c"
	{
#line 274 "../src/Utility/AsyncTask.vala"
		if (self->status == APP_STATUS_RUNNING) {
#line 1261 "AsyncTask.c"
			GDataOutputStream* _tmp0_;
			gchar* _tmp1_;
			gchar* _tmp2_;
#line 275 "../src/Utility/AsyncTask.vala"
			_tmp0_ = self->priv->dos_in;
#line 275 "../src/Utility/AsyncTask.vala"
			_tmp1_ = g_strconcat (line, "\n", NULL);
#line 275 "../src/Utility/AsyncTask.vala"
			_tmp2_ = _tmp1_;
#line 275 "../src/Utility/AsyncTask.vala"
			g_data_output_stream_put_string (_tmp0_, _tmp2_, NULL, &_inner_error0_);
#line 275 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp2_);
#line 275 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1277 "AsyncTask.c"
				goto __catch0_g_error;
			}
		} else {
#line 278 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_error ("AsyncTask.write_stdin(): NOT RUNNING", FALSE, FALSE);
#line 1283 "AsyncTask.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 273 "../src/Utility/AsyncTask.vala"
		e = _inner_error0_;
#line 273 "../src/Utility/AsyncTask.vala"
		_inner_error0_ = NULL;
#line 282 "../src/Utility/AsyncTask.vala"
		_tmp3_ = g_strdup_printf ("AsyncTask.write_stdin(): %s", line);
#line 282 "../src/Utility/AsyncTask.vala"
		_tmp4_ = _tmp3_;
#line 282 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 282 "../src/Utility/AsyncTask.vala"
		_g_free0 (_tmp4_);
#line 283 "../src/Utility/AsyncTask.vala"
		_tmp5_ = e;
#line 283 "../src/Utility/AsyncTask.vala"
		_tmp6_ = _tmp5_->message;
#line 283 "../src/Utility/AsyncTask.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 273 "../src/Utility/AsyncTask.vala"
		_g_error_free0 (e);
#line 1314 "AsyncTask.c"
	}
	__finally0:
#line 273 "../src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 273 "../src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 273 "../src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 273 "../src/Utility/AsyncTask.vala"
		return;
#line 1325 "AsyncTask.c"
	}
}

static void
async_task_real_parse_stdout_line (AsyncTask* self,
                                   const gchar* out_line)
{
#line 287 "../src/Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_parse_stdout_line'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 287 "../src/Utility/AsyncTask.vala"
	return;
#line 1337 "AsyncTask.c"
}

void
async_task_parse_stdout_line (AsyncTask* self,
                              const gchar* out_line)
{
	AsyncTaskClass* _klass_;
#line 287 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/Utility/AsyncTask.vala"
	_klass_ = ASYNC_TASK_GET_CLASS (self);
#line 287 "../src/Utility/AsyncTask.vala"
	if (_klass_->parse_stdout_line) {
#line 287 "../src/Utility/AsyncTask.vala"
		_klass_->parse_stdout_line (self, out_line);
#line 1353 "AsyncTask.c"
	}
}

static void
async_task_real_parse_stderr_line (AsyncTask* self,
                                   const gchar* err_line)
{
#line 289 "../src/Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_parse_stderr_line'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 289 "../src/Utility/AsyncTask.vala"
	return;
#line 1365 "AsyncTask.c"
}

void
async_task_parse_stderr_line (AsyncTask* self,
                              const gchar* err_line)
{
	AsyncTaskClass* _klass_;
#line 289 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/Utility/AsyncTask.vala"
	_klass_ = ASYNC_TASK_GET_CLASS (self);
#line 289 "../src/Utility/AsyncTask.vala"
	if (_klass_->parse_stderr_line) {
#line 289 "../src/Utility/AsyncTask.vala"
		_klass_->parse_stderr_line (self, err_line);
#line 1381 "AsyncTask.c"
	}
}

static void
async_task_finish (AsyncTask* self)
{
	gchar* _tmp12_;
	gchar* _tmp13_;
	GTimer* _tmp14_;
	gboolean _tmp15_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 291 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 294 "../src/Utility/AsyncTask.vala"
	if (self->priv->finish_called) {
#line 294 "../src/Utility/AsyncTask.vala"
		return;
#line 1399 "AsyncTask.c"
	}
#line 295 "../src/Utility/AsyncTask.vala"
	self->priv->finish_called = TRUE;
#line 297 "../src/Utility/AsyncTask.vala"
	tee_jee_logging_log_debug ("AsyncTask: finish(): enter");
#line 1405 "AsyncTask.c"
	{
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		GDataOutputStream* _tmp2_;
#line 301 "../src/Utility/AsyncTask.vala"
		_tmp2_ = self->priv->dos_in;
#line 301 "../src/Utility/AsyncTask.vala"
		if (_tmp2_ != NULL) {
#line 1414 "AsyncTask.c"
			GDataOutputStream* _tmp3_;
#line 301 "../src/Utility/AsyncTask.vala"
			_tmp3_ = self->priv->dos_in;
#line 301 "../src/Utility/AsyncTask.vala"
			_tmp1_ = !g_output_stream_is_closed ((GOutputStream*) _tmp3_);
#line 1420 "AsyncTask.c"
		} else {
#line 301 "../src/Utility/AsyncTask.vala"
			_tmp1_ = FALSE;
#line 1424 "AsyncTask.c"
		}
#line 301 "../src/Utility/AsyncTask.vala"
		if (_tmp1_) {
#line 1428 "AsyncTask.c"
			GDataOutputStream* _tmp4_;
#line 301 "../src/Utility/AsyncTask.vala"
			_tmp4_ = self->priv->dos_in;
#line 301 "../src/Utility/AsyncTask.vala"
			_tmp0_ = !g_output_stream_is_closing ((GOutputStream*) _tmp4_);
#line 1434 "AsyncTask.c"
		} else {
#line 301 "../src/Utility/AsyncTask.vala"
			_tmp0_ = FALSE;
#line 1438 "AsyncTask.c"
		}
#line 301 "../src/Utility/AsyncTask.vala"
		if (_tmp0_) {
#line 1442 "AsyncTask.c"
			GDataOutputStream* _tmp5_;
#line 302 "../src/Utility/AsyncTask.vala"
			_tmp5_ = self->priv->dos_in;
#line 302 "../src/Utility/AsyncTask.vala"
			g_output_stream_close ((GOutputStream*) _tmp5_, NULL, &_inner_error0_);
#line 302 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1450 "AsyncTask.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 300 "../src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 1460 "AsyncTask.c"
	}
	__finally0:
#line 300 "../src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 300 "../src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 300 "../src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 300 "../src/Utility/AsyncTask.vala"
		return;
#line 1471 "AsyncTask.c"
	}
#line 311 "../src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dos_in);
#line 311 "../src/Utility/AsyncTask.vala"
	self->priv->dos_in = NULL;
#line 312 "../src/Utility/AsyncTask.vala"
	close (self->priv->input_fd);
#line 315 "../src/Utility/AsyncTask.vala"
	g_spawn_close_pid (self->child_pid);
#line 1481 "AsyncTask.c"
	{
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		GDataOutputStream* _tmp8_;
#line 319 "../src/Utility/AsyncTask.vala"
		_tmp8_ = self->dos_log;
#line 319 "../src/Utility/AsyncTask.vala"
		if (_tmp8_ != NULL) {
#line 1490 "AsyncTask.c"
			GDataOutputStream* _tmp9_;
#line 319 "../src/Utility/AsyncTask.vala"
			_tmp9_ = self->dos_log;
#line 319 "../src/Utility/AsyncTask.vala"
			_tmp7_ = !g_output_stream_is_closed ((GOutputStream*) _tmp9_);
#line 1496 "AsyncTask.c"
		} else {
#line 319 "../src/Utility/AsyncTask.vala"
			_tmp7_ = FALSE;
#line 1500 "AsyncTask.c"
		}
#line 319 "../src/Utility/AsyncTask.vala"
		if (_tmp7_) {
#line 1504 "AsyncTask.c"
			GDataOutputStream* _tmp10_;
#line 319 "../src/Utility/AsyncTask.vala"
			_tmp10_ = self->dos_log;
#line 319 "../src/Utility/AsyncTask.vala"
			_tmp6_ = !g_output_stream_is_closing ((GOutputStream*) _tmp10_);
#line 1510 "AsyncTask.c"
		} else {
#line 319 "../src/Utility/AsyncTask.vala"
			_tmp6_ = FALSE;
#line 1514 "AsyncTask.c"
		}
#line 319 "../src/Utility/AsyncTask.vala"
		if (_tmp6_) {
#line 1518 "AsyncTask.c"
			GDataOutputStream* _tmp11_;
#line 320 "../src/Utility/AsyncTask.vala"
			_tmp11_ = self->dos_log;
#line 320 "../src/Utility/AsyncTask.vala"
			g_output_stream_close ((GOutputStream*) _tmp11_, NULL, &_inner_error0_);
#line 320 "../src/Utility/AsyncTask.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1526 "AsyncTask.c"
				goto __catch1_g_error;
			}
		}
#line 322 "../src/Utility/AsyncTask.vala"
		_g_object_unref0 (self->dos_log);
#line 322 "../src/Utility/AsyncTask.vala"
		self->dos_log = NULL;
#line 1534 "AsyncTask.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 317 "../src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 1541 "AsyncTask.c"
	}
	__finally1:
#line 317 "../src/Utility/AsyncTask.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 317 "../src/Utility/AsyncTask.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 317 "../src/Utility/AsyncTask.vala"
		g_clear_error (&_inner_error0_);
#line 317 "../src/Utility/AsyncTask.vala"
		return;
#line 1552 "AsyncTask.c"
	}
#line 330 "../src/Utility/AsyncTask.vala"
	async_task_read_exit_code (self);
#line 332 "../src/Utility/AsyncTask.vala"
	async_task_set_status_line (self, "");
#line 333 "../src/Utility/AsyncTask.vala"
	_tmp12_ = g_strdup ("");
#line 333 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->err_line);
#line 333 "../src/Utility/AsyncTask.vala"
	self->priv->err_line = _tmp12_;
#line 334 "../src/Utility/AsyncTask.vala"
	_tmp13_ = g_strdup ("");
#line 334 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->out_line);
#line 334 "../src/Utility/AsyncTask.vala"
	self->priv->out_line = _tmp13_;
#line 336 "../src/Utility/AsyncTask.vala"
	_tmp14_ = self->timer;
#line 336 "../src/Utility/AsyncTask.vala"
	g_timer_stop (_tmp14_);
#line 338 "../src/Utility/AsyncTask.vala"
	async_task_finish_task (self);
#line 340 "../src/Utility/AsyncTask.vala"
	if (self->status != APP_STATUS_CANCELLED) {
#line 340 "../src/Utility/AsyncTask.vala"
		_tmp15_ = self->status != APP_STATUS_PASSWORD_REQUIRED;
#line 1580 "AsyncTask.c"
	} else {
#line 340 "../src/Utility/AsyncTask.vala"
		_tmp15_ = FALSE;
#line 1584 "AsyncTask.c"
	}
#line 340 "../src/Utility/AsyncTask.vala"
	if (_tmp15_) {
#line 341 "../src/Utility/AsyncTask.vala"
		self->status = APP_STATUS_FINISHED;
#line 1590 "AsyncTask.c"
	}
#line 346 "../src/Utility/AsyncTask.vala"
	g_signal_emit (self, async_task_signals[ASYNC_TASK_TASK_COMPLETE_SIGNAL], 0);
#line 1594 "AsyncTask.c"
}

static void
async_task_real_finish_task (AsyncTask* self)
{
#line 349 "../src/Utility/AsyncTask.vala"
	g_critical ("Type `%s' does not implement abstract method `async_task_finish_task'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 349 "../src/Utility/AsyncTask.vala"
	return;
#line 1604 "AsyncTask.c"
}

void
async_task_finish_task (AsyncTask* self)
{
	AsyncTaskClass* _klass_;
#line 349 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 349 "../src/Utility/AsyncTask.vala"
	_klass_ = ASYNC_TASK_GET_CLASS (self);
#line 349 "../src/Utility/AsyncTask.vala"
	if (_klass_->finish_task) {
#line 349 "../src/Utility/AsyncTask.vala"
		_klass_->finish_task (self);
#line 1619 "AsyncTask.c"
	}
}

gint
async_task_read_exit_code (AsyncTask* self)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint result;
#line 351 "../src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 353 "../src/Utility/AsyncTask.vala"
	self->exit_code = -1;
#line 354 "../src/Utility/AsyncTask.vala"
	_tmp0_ = self->script_file;
#line 354 "../src/Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_file_system_file_parent (_tmp0_);
#line 354 "../src/Utility/AsyncTask.vala"
	_tmp2_ = _tmp1_;
#line 354 "../src/Utility/AsyncTask.vala"
	_tmp3_ = g_strconcat (_tmp2_, "/status", NULL);
#line 354 "../src/Utility/AsyncTask.vala"
	_tmp4_ = _tmp3_;
#line 354 "../src/Utility/AsyncTask.vala"
	_g_free0 (_tmp2_);
#line 354 "../src/Utility/AsyncTask.vala"
	path = _tmp4_;
#line 355 "../src/Utility/AsyncTask.vala"
	_tmp5_ = path;
#line 355 "../src/Utility/AsyncTask.vala"
	if (tee_jee_file_system_file_exists (_tmp5_)) {
#line 1658 "AsyncTask.c"
		gchar* txt = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 356 "../src/Utility/AsyncTask.vala"
		_tmp6_ = path;
#line 356 "../src/Utility/AsyncTask.vala"
		_tmp7_ = tee_jee_file_system_file_read (_tmp6_);
#line 356 "../src/Utility/AsyncTask.vala"
		txt = _tmp7_;
#line 357 "../src/Utility/AsyncTask.vala"
		_tmp8_ = txt;
#line 357 "../src/Utility/AsyncTask.vala"
		self->exit_code = atoi (_tmp8_);
#line 355 "../src/Utility/AsyncTask.vala"
		_g_free0 (txt);
#line 1675 "AsyncTask.c"
	}
#line 359 "../src/Utility/AsyncTask.vala"
	_tmp9_ = g_strdup_printf ("exit_code: %d", self->exit_code);
#line 359 "../src/Utility/AsyncTask.vala"
	_tmp10_ = _tmp9_;
#line 359 "../src/Utility/AsyncTask.vala"
	tee_jee_logging_log_debug (_tmp10_);
#line 359 "../src/Utility/AsyncTask.vala"
	_g_free0 (_tmp10_);
#line 360 "../src/Utility/AsyncTask.vala"
	result = self->exit_code;
#line 360 "../src/Utility/AsyncTask.vala"
	_g_free0 (path);
#line 360 "../src/Utility/AsyncTask.vala"
	return result;
#line 1691 "AsyncTask.c"
}

gboolean
async_task_is_running (AsyncTask* self)
{
	gboolean result;
#line 363 "../src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 365 "../src/Utility/AsyncTask.vala"
	result = self->status == APP_STATUS_RUNNING;
#line 365 "../src/Utility/AsyncTask.vala"
	return result;
#line 1704 "AsyncTask.c"
}

void
async_task_stop (AsyncTask* self,
                 AppStatus status_to_update)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 370 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 372 "../src/Utility/AsyncTask.vala"
	self->status = status_to_update;
#line 374 "../src/Utility/AsyncTask.vala"
	tee_jee_process_helper_process_quit (self->child_pid, TRUE);
#line 376 "../src/Utility/AsyncTask.vala"
	_tmp0_ = g_strdup_printf ("process_quit: %d", (gint) self->child_pid);
#line 376 "../src/Utility/AsyncTask.vala"
	_tmp1_ = _tmp0_;
#line 376 "../src/Utility/AsyncTask.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 376 "../src/Utility/AsyncTask.vala"
	_g_free0 (_tmp1_);
#line 1727 "AsyncTask.c"
}

void
async_task_set_priority (AsyncTask* self)
{
#line 379 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 381 "../src/Utility/AsyncTask.vala"
	if (self->background_mode) {
#line 382 "../src/Utility/AsyncTask.vala"
		async_task_set_priority_value (self, 5);
#line 1739 "AsyncTask.c"
	} else {
#line 385 "../src/Utility/AsyncTask.vala"
		async_task_set_priority_value (self, 0);
#line 1743 "AsyncTask.c"
	}
}

void
async_task_set_priority_value (AsyncTask* self,
                               gint prio)
{
	GPid app_pid = 0;
#line 389 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 391 "../src/Utility/AsyncTask.vala"
	app_pid = (GPid) getpid ();
#line 392 "../src/Utility/AsyncTask.vala"
	tee_jee_process_helper_process_set_priority (app_pid, prio);
#line 394 "../src/Utility/AsyncTask.vala"
	if (self->status == APP_STATUS_RUNNING) {
#line 1760 "AsyncTask.c"
		GPid sub_child_pid = 0;
		gint _tmp0_ = 0;
		gint* _tmp1_;
#line 395 "../src/Utility/AsyncTask.vala"
		tee_jee_process_helper_process_set_priority (self->child_pid, prio);
#line 398 "../src/Utility/AsyncTask.vala"
		_tmp1_ = tee_jee_process_helper_get_process_children (self->child_pid, &_tmp0_);
#line 1768 "AsyncTask.c"
		{
			gint* pid_collection = NULL;
			gint pid_collection_length1 = 0;
			gint _pid_collection_size_ = 0;
			gint pid_it = 0;
#line 398 "../src/Utility/AsyncTask.vala"
			pid_collection = _tmp1_;
#line 398 "../src/Utility/AsyncTask.vala"
			pid_collection_length1 = _tmp0_;
#line 398 "../src/Utility/AsyncTask.vala"
			for (pid_it = 0; pid_it < pid_collection_length1; pid_it = pid_it + 1) {
#line 1780 "AsyncTask.c"
				glong pid = 0L;
#line 398 "../src/Utility/AsyncTask.vala"
				pid = (glong) pid_collection[pid_it];
#line 1784 "AsyncTask.c"
				{
#line 399 "../src/Utility/AsyncTask.vala"
					sub_child_pid = (GPid) pid;
#line 400 "../src/Utility/AsyncTask.vala"
					tee_jee_process_helper_process_set_priority (sub_child_pid, prio);
#line 1790 "AsyncTask.c"
				}
			}
#line 398 "../src/Utility/AsyncTask.vala"
			pid_collection = (g_free (pid_collection), NULL);
#line 1795 "AsyncTask.c"
		}
	}
}

void
async_task_print_app_status (AsyncTask* self)
{
#line 428 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/Utility/AsyncTask.vala"
	switch (self->status) {
#line 430 "../src/Utility/AsyncTask.vala"
		case APP_STATUS_NOT_STARTED:
#line 1809 "AsyncTask.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 432 "../src/Utility/AsyncTask.vala"
			_tmp0_ = g_strdup_printf ("status=%s", "NOT_STARTED");
#line 432 "../src/Utility/AsyncTask.vala"
			_tmp1_ = _tmp0_;
#line 432 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp1_);
#line 432 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp1_);
#line 433 "../src/Utility/AsyncTask.vala"
			break;
#line 1823 "AsyncTask.c"
		}
#line 430 "../src/Utility/AsyncTask.vala"
		case APP_STATUS_RUNNING:
#line 1827 "AsyncTask.c"
		{
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 435 "../src/Utility/AsyncTask.vala"
			_tmp2_ = g_strdup_printf ("status=%s", "RUNNING");
#line 435 "../src/Utility/AsyncTask.vala"
			_tmp3_ = _tmp2_;
#line 435 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp3_);
#line 435 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp3_);
#line 436 "../src/Utility/AsyncTask.vala"
			break;
#line 1841 "AsyncTask.c"
		}
#line 430 "../src/Utility/AsyncTask.vala"
		case APP_STATUS_PAUSED:
#line 1845 "AsyncTask.c"
		{
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 438 "../src/Utility/AsyncTask.vala"
			_tmp4_ = g_strdup_printf ("status=%s", "PAUSED");
#line 438 "../src/Utility/AsyncTask.vala"
			_tmp5_ = _tmp4_;
#line 438 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp5_);
#line 438 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp5_);
#line 439 "../src/Utility/AsyncTask.vala"
			break;
#line 1859 "AsyncTask.c"
		}
#line 430 "../src/Utility/AsyncTask.vala"
		case APP_STATUS_FINISHED:
#line 1863 "AsyncTask.c"
		{
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 441 "../src/Utility/AsyncTask.vala"
			_tmp6_ = g_strdup_printf ("status=%s", "FINISHED");
#line 441 "../src/Utility/AsyncTask.vala"
			_tmp7_ = _tmp6_;
#line 441 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp7_);
#line 441 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp7_);
#line 442 "../src/Utility/AsyncTask.vala"
			break;
#line 1877 "AsyncTask.c"
		}
#line 430 "../src/Utility/AsyncTask.vala"
		case APP_STATUS_CANCELLED:
#line 1881 "AsyncTask.c"
		{
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 444 "../src/Utility/AsyncTask.vala"
			_tmp8_ = g_strdup_printf ("status=%s", "CANCELLED");
#line 444 "../src/Utility/AsyncTask.vala"
			_tmp9_ = _tmp8_;
#line 444 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp9_);
#line 444 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp9_);
#line 445 "../src/Utility/AsyncTask.vala"
			break;
#line 1895 "AsyncTask.c"
		}
#line 430 "../src/Utility/AsyncTask.vala"
		case APP_STATUS_PASSWORD_REQUIRED:
#line 1899 "AsyncTask.c"
		{
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 447 "../src/Utility/AsyncTask.vala"
			_tmp10_ = g_strdup_printf ("status=%s", "PASSWORD_REQUIRED");
#line 447 "../src/Utility/AsyncTask.vala"
			_tmp11_ = _tmp10_;
#line 447 "../src/Utility/AsyncTask.vala"
			tee_jee_logging_log_debug (_tmp11_);
#line 447 "../src/Utility/AsyncTask.vala"
			_g_free0 (_tmp11_);
#line 448 "../src/Utility/AsyncTask.vala"
			break;
#line 1913 "AsyncTask.c"
		}
		default:
#line 430 "../src/Utility/AsyncTask.vala"
		break;
#line 1918 "AsyncTask.c"
	}
}

gchar*
async_task_get_status_line (AsyncTask* self)
{
	gchar* result;
	gchar* _tmp0_;
#line 82 "../src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "../src/Utility/AsyncTask.vala"
	_tmp0_ = _async_task_get_status_line (self);
#line 83 "../src/Utility/AsyncTask.vala"
	result = _tmp0_;
#line 83 "../src/Utility/AsyncTask.vala"
	return result;
#line 1935 "AsyncTask.c"
}

void
async_task_set_status_line (AsyncTask* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 86 "../src/Utility/AsyncTask.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/Utility/AsyncTask.vala"
	g_mutex_lock (&self->status_line_mutex);
#line 89 "../src/Utility/AsyncTask.vala"
	_tmp0_ = g_strdup (value);
#line 89 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->_status_line);
#line 89 "../src/Utility/AsyncTask.vala"
	self->priv->_status_line = _tmp0_;
#line 90 "../src/Utility/AsyncTask.vala"
	g_mutex_unlock (&self->status_line_mutex);
#line 1955 "AsyncTask.c"
}

gchar*
async_task_get_stat_time_elapsed (AsyncTask* self)
{
	gchar* result;
	glong elapsed = 0L;
	GTimer* _tmp0_;
	gchar* _tmp1_;
#line 406 "../src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 407 "../src/Utility/AsyncTask.vala"
	_tmp0_ = self->timer;
#line 407 "../src/Utility/AsyncTask.vala"
	elapsed = (glong) tee_jee_system_timer_elapsed (_tmp0_, TRUE);
#line 408 "../src/Utility/AsyncTask.vala"
	_tmp1_ = tee_jee_misc_format_duration (elapsed);
#line 408 "../src/Utility/AsyncTask.vala"
	result = _tmp1_;
#line 408 "../src/Utility/AsyncTask.vala"
	return result;
#line 1977 "AsyncTask.c"
}

gchar*
async_task_get_stat_time_remaining (AsyncTask* self)
{
	gchar* result;
#line 413 "../src/Utility/AsyncTask.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 414 "../src/Utility/AsyncTask.vala"
	if (self->progress > ((gdouble) 0)) {
#line 1988 "AsyncTask.c"
		glong elapsed = 0L;
		GTimer* _tmp0_;
		glong remaining = 0L;
		gchar* _tmp1_;
#line 415 "../src/Utility/AsyncTask.vala"
		_tmp0_ = self->timer;
#line 415 "../src/Utility/AsyncTask.vala"
		elapsed = (glong) tee_jee_system_timer_elapsed (_tmp0_, TRUE);
#line 416 "../src/Utility/AsyncTask.vala"
		remaining = (glong) ((elapsed / self->progress) * (1.0 - self->progress));
#line 417 "../src/Utility/AsyncTask.vala"
		if (remaining < ((glong) 0)) {
#line 418 "../src/Utility/AsyncTask.vala"
			remaining = (glong) 0;
#line 2003 "AsyncTask.c"
		}
#line 420 "../src/Utility/AsyncTask.vala"
		_tmp1_ = tee_jee_misc_format_duration (remaining);
#line 420 "../src/Utility/AsyncTask.vala"
		result = _tmp1_;
#line 420 "../src/Utility/AsyncTask.vala"
		return result;
#line 2011 "AsyncTask.c"
	} else {
		gchar* _tmp2_;
#line 423 "../src/Utility/AsyncTask.vala"
		_tmp2_ = g_strdup ("???");
#line 423 "../src/Utility/AsyncTask.vala"
		result = _tmp2_;
#line 423 "../src/Utility/AsyncTask.vala"
		return result;
#line 2020 "AsyncTask.c"
	}
}

static void
async_task_class_init (AsyncTaskClass * klass,
                       gpointer klass_data)
{
#line 31 "../src/Utility/AsyncTask.vala"
	async_task_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/Utility/AsyncTask.vala"
	g_type_class_adjust_private_offset (klass, &AsyncTask_private_offset);
#line 31 "../src/Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stdout_line = (void (*) (AsyncTask*, const gchar*)) async_task_real_parse_stdout_line;
#line 31 "../src/Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->parse_stderr_line = (void (*) (AsyncTask*, const gchar*)) async_task_real_parse_stderr_line;
#line 31 "../src/Utility/AsyncTask.vala"
	((AsyncTaskClass *) klass)->finish_task = (void (*) (AsyncTask*)) async_task_real_finish_task;
#line 31 "../src/Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_async_task_get_property;
#line 31 "../src/Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_async_task_set_property;
#line 31 "../src/Utility/AsyncTask.vala"
	G_OBJECT_CLASS (klass)->finalize = async_task_finalize;
#line 31 "../src/Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STATUS_LINE_PROPERTY, async_task_properties[ASYNC_TASK_STATUS_LINE_PROPERTY] = g_param_spec_string ("status-line", "status-line", "status-line", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 31 "../src/Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY, async_task_properties[ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY] = g_param_spec_string ("stat-time-elapsed", "stat-time-elapsed", "stat-time-elapsed", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/Utility/AsyncTask.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY, async_task_properties[ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY] = g_param_spec_string ("stat-time-remaining", "stat-time-remaining", "stat-time-remaining", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_STDOUT_LINE_READ_SIGNAL] = g_signal_new ("stdout-line-read", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 31 "../src/Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_STDERR_LINE_READ_SIGNAL] = g_signal_new ("stderr-line-read", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 31 "../src/Utility/AsyncTask.vala"
	async_task_signals[ASYNC_TASK_TASK_COMPLETE_SIGNAL] = g_signal_new ("task-complete", TYPE_ASYNC_TASK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2056 "AsyncTask.c"
}

static void
async_task_instance_init (AsyncTask * self,
                          gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 31 "../src/Utility/AsyncTask.vala"
	self->priv = async_task_get_instance_private (self);
#line 33 "../src/Utility/AsyncTask.vala"
	_tmp0_ = g_strdup ("");
#line 33 "../src/Utility/AsyncTask.vala"
	self->priv->err_line = _tmp0_;
#line 34 "../src/Utility/AsyncTask.vala"
	_tmp1_ = g_strdup ("");
#line 34 "../src/Utility/AsyncTask.vala"
	self->priv->out_line = _tmp1_;
#line 39 "../src/Utility/AsyncTask.vala"
	self->is_terminated = FALSE;
#line 41 "../src/Utility/AsyncTask.vala"
	self->priv->stdout_is_open = FALSE;
#line 42 "../src/Utility/AsyncTask.vala"
	self->priv->stderr_is_open = FALSE;
#line 48 "../src/Utility/AsyncTask.vala"
	self->priv->finish_called = FALSE;
#line 50 "../src/Utility/AsyncTask.vala"
	_tmp2_ = g_strdup ("");
#line 50 "../src/Utility/AsyncTask.vala"
	self->script_file = _tmp2_;
#line 51 "../src/Utility/AsyncTask.vala"
	_tmp3_ = g_strdup ("");
#line 51 "../src/Utility/AsyncTask.vala"
	self->working_dir = _tmp3_;
#line 52 "../src/Utility/AsyncTask.vala"
	_tmp4_ = g_strdup ("");
#line 52 "../src/Utility/AsyncTask.vala"
	self->log_file = _tmp4_;
#line 54 "../src/Utility/AsyncTask.vala"
	self->background_mode = FALSE;
#line 59 "../src/Utility/AsyncTask.vala"
	_tmp5_ = g_strdup ("");
#line 59 "../src/Utility/AsyncTask.vala"
	self->priv->_status_line = _tmp5_;
#line 62 "../src/Utility/AsyncTask.vala"
	self->exit_code = 0;
#line 63 "../src/Utility/AsyncTask.vala"
	_tmp6_ = g_strdup ("");
#line 63 "../src/Utility/AsyncTask.vala"
	self->error_msg = _tmp6_;
#line 65 "../src/Utility/AsyncTask.vala"
	self->progress = 0.0;
#line 66 "../src/Utility/AsyncTask.vala"
	self->percent = 0.0;
#line 67 "../src/Utility/AsyncTask.vala"
	self->prg_count = (gint64) 0;
#line 68 "../src/Utility/AsyncTask.vala"
	self->prg_count_total = (gint64) 0;
#line 69 "../src/Utility/AsyncTask.vala"
	self->prg_bytes = (gint64) 0;
#line 70 "../src/Utility/AsyncTask.vala"
	self->prg_bytes_total = (gint64) 0;
#line 71 "../src/Utility/AsyncTask.vala"
	_tmp7_ = g_strdup ("");
#line 71 "../src/Utility/AsyncTask.vala"
	self->eta = _tmp7_;
#line 2129 "AsyncTask.c"
}

static void
async_task_finalize (GObject * obj)
{
	AsyncTask * self;
#line 31 "../src/Utility/AsyncTask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASYNC_TASK, AsyncTask);
#line 33 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->err_line);
#line 34 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->out_line);
#line 35 "../src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dos_in);
#line 36 "../src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dis_out);
#line 37 "../src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->priv->dis_err);
#line 38 "../src/Utility/AsyncTask.vala"
	_g_object_unref0 (self->dos_log);
#line 50 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->script_file);
#line 51 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->working_dir);
#line 52 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->log_file);
#line 59 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->priv->_status_line);
#line 60 "../src/Utility/AsyncTask.vala"
	_vala_clear_GMutex (&self->status_line_mutex);
#line 63 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->error_msg);
#line 64 "../src/Utility/AsyncTask.vala"
	_g_timer_destroy0 (self->timer);
#line 71 "../src/Utility/AsyncTask.vala"
	_g_free0 (self->eta);
#line 31 "../src/Utility/AsyncTask.vala"
	G_OBJECT_CLASS (async_task_parent_class)->finalize (obj);
#line 2168 "AsyncTask.c"
}

static GType
async_task_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AsyncTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) async_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AsyncTask), 0, (GInstanceInitFunc) async_task_instance_init, NULL };
	GType async_task_type_id;
	async_task_type_id = g_type_register_static (G_TYPE_OBJECT, "AsyncTask", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	AsyncTask_private_offset = g_type_add_instance_private (async_task_type_id, sizeof (AsyncTaskPrivate));
	return async_task_type_id;
}

GType
async_task_get_type (void)
{
	static volatile gsize async_task_type_id__once = 0;
	if (g_once_init_enter (&async_task_type_id__once)) {
		GType async_task_type_id;
		async_task_type_id = async_task_get_type_once ();
		g_once_init_leave (&async_task_type_id__once, async_task_type_id);
	}
	return async_task_type_id__once;
}

static void
_vala_async_task_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	AsyncTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASYNC_TASK, AsyncTask);
#line 31 "../src/Utility/AsyncTask.vala"
	switch (property_id) {
#line 31 "../src/Utility/AsyncTask.vala"
		case ASYNC_TASK_STATUS_LINE_PROPERTY:
#line 31 "../src/Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_status_line (self));
#line 31 "../src/Utility/AsyncTask.vala"
		break;
#line 31 "../src/Utility/AsyncTask.vala"
		case ASYNC_TASK_STAT_TIME_ELAPSED_PROPERTY:
#line 31 "../src/Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_stat_time_elapsed (self));
#line 31 "../src/Utility/AsyncTask.vala"
		break;
#line 31 "../src/Utility/AsyncTask.vala"
		case ASYNC_TASK_STAT_TIME_REMAINING_PROPERTY:
#line 31 "../src/Utility/AsyncTask.vala"
		g_value_take_string (value, async_task_get_stat_time_remaining (self));
#line 31 "../src/Utility/AsyncTask.vala"
		break;
#line 2221 "AsyncTask.c"
		default:
#line 31 "../src/Utility/AsyncTask.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/Utility/AsyncTask.vala"
		break;
#line 2227 "AsyncTask.c"
	}
}

static void
_vala_async_task_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	AsyncTask * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASYNC_TASK, AsyncTask);
#line 31 "../src/Utility/AsyncTask.vala"
	switch (property_id) {
#line 31 "../src/Utility/AsyncTask.vala"
		case ASYNC_TASK_STATUS_LINE_PROPERTY:
#line 31 "../src/Utility/AsyncTask.vala"
		async_task_set_status_line (self, g_value_get_string (value));
#line 31 "../src/Utility/AsyncTask.vala"
		break;
#line 2247 "AsyncTask.c"
		default:
#line 31 "../src/Utility/AsyncTask.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/Utility/AsyncTask.vala"
		break;
#line 2253 "AsyncTask.c"
	}
}

static GType
app_status_get_type_once (void)
{
	static const GEnumValue values[] = {{APP_STATUS_NOT_STARTED, "APP_STATUS_NOT_STARTED", "not-started"}, {APP_STATUS_RUNNING, "APP_STATUS_RUNNING", "running"}, {APP_STATUS_PAUSED, "APP_STATUS_PAUSED", "paused"}, {APP_STATUS_FINISHED, "APP_STATUS_FINISHED", "finished"}, {APP_STATUS_CANCELLED, "APP_STATUS_CANCELLED", "cancelled"}, {APP_STATUS_PASSWORD_REQUIRED, "APP_STATUS_PASSWORD_REQUIRED", "password-required"}, {0, NULL, NULL}};
	GType app_status_type_id;
	app_status_type_id = g_enum_register_static ("AppStatus", values);
	return app_status_type_id;
}

GType
app_status_get_type (void)
{
	static volatile gsize app_status_type_id__once = 0;
	if (g_once_init_enter (&app_status_type_id__once)) {
		GType app_status_type_id;
		app_status_type_id = app_status_get_type_once ();
		g_once_init_leave (&app_status_type_id__once, app_status_type_id);
	}
	return app_status_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

